import VODUpload from './../../util/aliyun-upload-sdk-1.0.1.min.js'

Page({
    //页面的初始数据
    data: {
        options: {},
        files: [],
        images: [],
        count: 1, // 最多可以选择的图片张数
        videos: [],
        videosCount: 1, // 最多可以选择的视频数
    },
    
    onLoad: function (option) {
        this.setData({
            options: option
        });
    },
    onReady: function () {
        var that = this;
        

        var uploader = new VODUpload({
            timeout: that.data.options.timeout || 60000,
            region: that.data.options.region || "cn-shanghai",
            // 添加文件成功
            addFileSuccess: function (uploadInfo) {
                console.log("addFileSuccess" + JSON.stringify(uploadInfo))

            },
            // 开始上传
            onUploadstarted: function (uploadInfo) {
                console.log('文件开始上传...');
                console.log("onUploadStarted:" + JSON.stringify(uploadInfo))
                wx.request({
                    //填入自己服务器IP
                    url: "http://*.*.*.*:8080/demo/getSts",
                    // data: data,
                    // header: header,
                    // method: method,
                    success: (res => {
                        if (res.statusCode === 200) {
                            var akInfo = res.data.data;
                            uploader.setSTSToken(uploadInfo, akInfo.accessKeyId, akInfo.accessKeySecret, akInfo.securityToken);
                        } else {
                            console.log(res)
                        }
                    }),
                    fail: (res => {
                        onError(res);
                    })
                });
            },
            // 文件上传成功
            onUploadSucceed: function (uploadInfo) {
                console.log('文件上传成功!'+ JSON.stringify(uploadInfo))
                if (uploadInfo.isImage) {
                    var app = getApp();
                    var coverObject = uploadInfo.object;
                    //填入自己配置的加速域名
                    app.globalData.wxCoverImage = "http://*****.***/" + coverObject;
                }
                var upload_user_token = getApp().globalData.userInfo.token
                var upload_cover_url = getApp().globalData.wxCoverImage
                var array = [];
                wx.request({
                    //填入自己服务器IP
                    url: "http://*.*.*.*:8080/vod/videoPublish",
                    header: {
                      "Content-Type": "application/x-www-form-urlencoded"
                    },
                    method: "POST",
                    data: {token:upload_user_token, videoId:uploadInfo.videoId, title:'测试视频', description:'点我播放', duration:0,coverUrl: upload_cover_url, size:uploadInfo.fileSize, tags:'0', cateId:0, cateName:'', PACKAGE_NAME:''},
                  });
                  console.log('post end!')
            },

            // 文件上传失败
            onUploadFailed: function (uploadInfo, code, message) {
                console.log("onUploadFailed: file:" + uploadInfo.file.name + ",code:" + code + ", message:" + message)
                console.log('文件上传失败!')
            },
            // 取消文件上传
            onUploadCanceled: function (uploadInfo, code, message) {
                console.log("Canceled file: " + uploadInfo.file.name + ", code: " + code + ", message:" + message)
                console.log('文件已暂停上传!')

            },
            // 文件上传进度，单位：字节, 可以在这个函数中拿到上传进度并显示在页面上
            onUploadProgress: function (uploadInfo, totalSize, progress) {

                var files;
                if (uploadInfo.isImage) {
                    files = that.data.images;
                } else {
                    files = that.data.videos;
                }

                files.forEach((file, idx) => {
                    if (file.url === uploadInfo.url) {
                        file.progress = progress;
                        if (uploadInfo.isImage) {
                            that.setData({
                                images: files
                            })
                        } else {
                            that.setData({
                                videos: files
                            })
                        }
                    }
                })

            },
            // 上传凭证超时
            onUploadTokenExpired: function (uploadInfo) {
                // // 如果是上传方式二即根据 STSToken 实现时，从新获取STS临时账号用于恢复上传
                // // 上传文件过大时可能在上传过程中 sts token 就会失效, 所以需要在 token 过期的回调中调用 resumeUploadWithSTSToken 方法
                // // 这里是测试接口, 所以我直接获取了 STSToken
            },
            // 全部文件上传结束
            onUploadEnd: function (uploadInfo) {
                wx.showToast({
                    title: '上传成功',
                    icon: 'success',
                    duration: 2000 // 提示的延迟时间
                })
                console.log("文件上传完毕 onUploadEnd: uploaded all the files")
            }
        });

        this.setData({
            uploader: uploader
        });

    },

    // 选择视频
    chooseVideo: function (e) {
        var that = this;
        wx.chooseMedia({
            sourceType: ['album', 'camera'],
            maxDuration: 60,
            compressed: false,
            camera: 'back',
            success: function (res) {
                var imagePath = res.tempFiles[0].thumbTempFilePath
                var file = {url: res.tempFiles[0].tempFilePath, coverUrl: imagePath};
                
                that.data.images = that.data.images.concat({'url': imagePath})
                
                var videosCount = --that.data.videosCount;
                var count =  videosCount;
                that.setData({
                    videosCount: videosCount,
                    count : count,
                    images : that.data.images,
                    videos: that.data.videos.concat(file)
                });

                var userData = '{"Vod":{}}'
                that.data.images.forEach(item => {
                    var uploader = that.data.uploader;
                    var userData = '{"Vod":{}}';
                    uploader.addFile(item, null, null, null, userData)
                })
                var uploader = that.data.uploader;
                uploader.addFile(file, null, null, null, userData)
                

            }
        })
    },
    removeVideo: function (event) {
        this.setData({
            videosCount: ++this.data.videosCount
        });
        var url = event.currentTarget.id;
        this.data.videos.forEach((video, idx) => {
            if (video.url === url) {
                this.data.videos.splice(idx, 1);
                this.data.uploader.deleteFile(idx);
                this.setData({
                    videos: this.data.videos
                });
            }
        })

    },
    // 预览图片
    previewImage: function (e) {
        wx.previewImage({
            current: e.currentTarget.id, // 当前显示图片的http链接
            urls: [e.currentTarget.id] // 需要预览的图片http链接列表
        })
    },
    //点击上传
    uploadImg: function (e) {
        this.data.uploader.startUpload();
    },
    uploadVideo: function (e) {
        this.data.uploader.startUpload();
    },
    _getSuffix: function (filename) {
        var pos = filename.lastIndexOf('.')
        var suffix = ''
        if (pos != -1) {
            suffix = filename.substring(++pos)
        }
        return suffix;
    }
})